const express = require("express"),
chokidar = require("chokidar"),
fs = require("fs"),
path = require("path"),
showdown = require("showdown"),
mkthtml = new showdown.Converter()

mkthtml.setFlavor("github")

const PORT = process.env.PORT || 8080

var dataPath = path.join(__dirname, 'data')
var postsPath = path.join(dataPath, 'posts')
var staticPath = path.join(__dirname, 'static')

var watcher = chokidar.watch(dataPath)

var app = express()

app.use(express.static(staticPath))

var reqPaths = [dataPath, postsPath]

for (var i = 0; i < reqPaths.length; i++) {
    var p = reqPaths[i]
    if (!fs.existsSync(p)) {
        fs.mkdirSync(p)
    }
}

app.listen(PORT, () => {
    console.log("Violet's Limbo is now listening on: " + PORT)
})

function pageUpdate() {
    var data = JSON.parse(fs.readFileSync(path.join(dataPath, 'data.json')))
    var postsArray = data.posts

    var html = ""

    for (var i = 0; i < postsArray.length; i++) {
        var addedHTML = ""
        var post = postsArray[i]
        

        addedHTML += 
        `<div class="project">
        <a style="text-decoration: none;" href="./post/${post.path}">
        <h2>${post.name}</h2>
        <p style="color: darkgray; font-size: 1rem;">Path: <code>/post/${post.path}</code></p>
        </a>
        </div>`

        html += addedHTML
    }

    var html = fs.readFileSync(path.join(__dirname, 'resources/mainPage.html')).toString().replace('{POSTS}', html)

    fs.writeFileSync(path.join(staticPath, 'index.html'), html)
}

watcher
    .on('change', pageUpdate)

app.get('/post/:post*', (req, res) => {
    var postName = req.params.post

    var data = JSON.parse(fs.readFileSync(path.join(dataPath, 'data.json')))
    var postsArray = data.posts

    for (let index = 0; index < postsArray.length; index++) {
        const post = postsArray[index];

        if (post.path == postName) {
            postContent = mkthtml.makeHtml(fs.readFileSync(path.join(postsPath, post.path)).toString())
    
            var html = fs.readFileSync(path.join(__dirname, 'resources/postPage.html')).toString()
        
            html = html.replace('{POST}', postContent)
            html = html.replace('{POST_TITLE}', post.name)
        
            res.send(html)
            return
        }
    }

    var html = fs.readFileSync(path.join(__dirname, 'resources/postPage.html')).toString()
    html = html.replace("{POST_TITLE}", "Not found!")
    html = html.replace("{POST}", "<p>Couldn't find this post... Maybe try clearing your cache? Violet's Limbo is currently going through alot of backend changes, so expect things to break!</p>")
    res.send(html)

    return
    
})